﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NLog;
using Ranet.Analytics.PivotGrid.Controllers;
using Ranet.Analytics.WebViewer.Olap;
using Ranet.Olap.Core.Common;
using Ranet.Web.Olap;

namespace Ranet.PivotTable.MVC.Controllers
{
    [RoutePrefix("api/olap")]
    public class CustomDataSourceController : DataSourceController
    {
        protected override SimpleDataTable SelectDrillThroughQuery (string connection, string query)
        {
            var adomdConnection = GetAdomdConnection(connection);
            var defaultQueryExecutor =
                new DefaultQueryExecuter(new ConnectionInfo(string.Empty, adomdConnection.ConnectionString),
                    adomdConnection);

            query += "RETURN [$Date].[Date],KEY([$Product].[Model Name]),NAME([$Employee].[Employee]),[Reseller Sales].[Reseller Sales Amount] ,[Reseller Sales].[Reseller Tax Amount],[Reseller Sales].[Reseller Standard Product Cost]";
                

            var dataTable = defaultQueryExecutor.ExecuteReader(query);

            var result = SimpleDataTable.Parse(dataTable);
            
            return result;
        }
    }
}
