﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http.Controllers;
using System.Web.Http.Routing;
using Ranet.Analytics.PivotGrid.Controllers;

namespace Ranet.PivotTable.MVC.Providers
{
    public class CustomDirectRouteProvider: DefaultDirectRouteProvider
    {
        protected override IReadOnlyList<IDirectRouteFactory> GetActionRouteFactories(HttpActionDescriptor actionDescriptor)
        {
            return actionDescriptor.GetCustomAttributes<IDirectRouteFactory>(true);
        }

        protected override string GetRoutePrefix(HttpControllerDescriptor controllerDescriptor)
        {
            var routePrefix = base.GetRoutePrefix(controllerDescriptor);
            var controllerType = controllerDescriptor.ControllerType;

            return controllerType == typeof(DataSourceController) ? null : routePrefix;
        }
    }
}